
/* USDP Sample Code
Display "Hi Iam USDP" on 7-segment displays.
Requires FPGA as feed through in between display and PIC.
*/

#include <pic1687x.h>

typedef unsigned int UINT;
typedef unsigned char UCHAR;
typedef unsigned long ULONG;

#define TIMER1_RELOADH	(0xfC)
#define TIMER1_RELOADL	(0x66)

static volatile bit SEL0   @ (unsigned)&PORTC*8+0;
static volatile bit SEL1   @ (unsigned)&PORTC*8+1;
static volatile bit SEL2   @ (unsigned)&PORTC*8+2;
static volatile bit SEL3   @ (unsigned)&PORTC*8+5;
static volatile bit TEST   @ (unsigned)&PORTC*8+4;

UINT count;
bit secflag;
UCHAR digit;
UINT digbuf[4];
UCHAR hi[4], iam[4], usdp[4];

void inithw(void)
{

	ADCON1 = 0x06; 
	INTCON = 0x00;
	OPTION = 0x00;

	TRISC = 0x00;
	TRISD = 0x00;

	TMR1H = TIMER1_RELOADH;
	TMR1L = TIMER1_RELOADL;

	RBPU = 1;
	INTEDG = 0;
	T0CS = 1;
	T0SE = 1;
	PSA = 1;

	T1CON = 0x01;

	INTE = 1;
	T0IE = 1;
	TMR1IE = 1;
	PEIE = 1;
	GIE  = 1;
}

void interrupt isr(void)
{
	if(TMR1IF)
	{
		TMR1IF = 0;
		TMR1H = TIMER1_RELOADH;
		TMR1L = TIMER1_RELOADL;
		TEST = !TEST;
		count++;

		switch(digit)
		{
			case 0 :
				SEL0 = 1; SEL1 = 0; SEL2 = 0; SEL3 = 0;
				break;
				
			case 1 :
				SEL0 = 0; SEL1 = 1; SEL2 = 0; SEL3 = 0;
				break;
				
			case 2 :
				SEL0 = 0; SEL1 = 0; SEL2 = 1; SEL3 = 0;
				break;
				
			case 3 :
				SEL0 = 0; SEL1 = 0; SEL2 = 0; SEL3 = 1;
				break;
			default :
				SEL2 = 0; SEL1 = 0; SEL0 = 0;SEL3 = 0;
				digit = 0;
				break;
		}
		PORTD = digbuf[digit];
		digit++;
		if(digit > 3)
			digit = 0;
	}
		
}

void delay(UINT delcnt)
{
    delcnt = count + delcnt;
    while(delcnt != count);
}

void main(void)
{
	UCHAR i;
	inithw();
// A 111 0111
// M 101 0101
	hi[0] = hi[1] = 0;
	hi[2] = 0x37;
	hi[3] = 0x30;
	iam[0] = 0x00;
	iam[1] = 0x30;
	iam[2] = 0x77;
	iam[3] = 0x55;
	usdp[0] = 0x3e;
	usdp[1] = 0x5b;
	usdp[2] = 0x3d;
	usdp[3] = 0x67;

    while(1) 
    {
		for(i = 0; i < 4; i++)
		    digbuf[i] = hi[i];
	    delay(3000);
		for(i = 0; i < 4; i++)
			digbuf[i] = iam[i];
		delay(3000);	
		for(i = 0; i < 4; i++)
	    	digbuf[i] = usdp[i];
	    delay(3000);
    }
}
